#!/bin/sh

tunnelfactor=$1
omega=0
run=$tunnelfactor

rm -r runturbine_$run
cp -r simpleFoam.template runturbine_$run
cd runturbine_$run

#change to k-omega
sed -i 's/epsilon/omega/' system/fvSchemes
sed -i 's/epsilon/omega/' system/fvSolution
sed -i 's/realizableKE/kOmegaSST/' constant/RASProperties

cp -r ../mesh_$tunnelfactor/constant/polyMesh constant/
cp -rf 0.org 0
setSet -batch system/setMRF

decomposePar -latestTime
mpirun -np 4 simpleFoam -parallel > log.simpleFoam
../post_moment_table.sh >> results.txt
reconstructPar -latestTime
yPlusRAS -latestTime
ptot -latestTime
