=begin

    Part of turbine model.
    Copyright (C) 2015  Björn Bergqvist

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    
    If you want to contact the author send an email: bjorn.bergqvist@gmail.com or
    phone +46 704-80 11 83.

=end

load 'tabularnaca.rb'
load 'stlcreate.rb'
#camber line calc
# x = x position
# p = location of maximum camber number, betwen 0 and 1
# m = maximum camber
# c = chord length
def yc_calc(x_in,p_in,m_in,c_in)
   x1=x_in.to_f/c_in
   p1=p_in.to_f
   c1=1.0
   #puts "x1 #{x1} p1 #{p1} m_in #{m_in} c1 #{c1}"
   if x1<p1
      return m_in*x1/p1**2*(2*p1-x1/c1)
   else
      return m_in*(c1-x1)/(1.0-p1)**2*(1+x1/c1-2*p1)
   end
end
# calculate xu yu (upper points) and xl yl (lower naca points)
# scalex = scale x-naca points with this
# scaley = scale y-naca points with this = thickness
# camberfrac = amount of camber fraction of tablespace*scalex
# camberlocfrac = camberlocation between 0 and 1
def camberstd(scalex,scaley,camberfrac,camberlocfrac,x,y,dydx)
   tablespace=100 #table x between 0 and 100
   camber=tablespace.to_f*camberfrac*scalex
   yc=Array.new
   xu=Array.new
   yu=Array.new
   xl=Array.new
   yl=Array.new
   xscaled=Array.new
   yscaled=Array.new
   (0..x.size-1).each do |idx|
      yscaled[idx]=y[idx]*scalex*scaley #scaley=thickness
      xscaled[idx]=x[idx]*scalex
      yc[idx]=yc_calc(xscaled[idx],camberlocfrac, camber, tablespace*scalex)
      #yc[idx]=0
      #puts yc[idx]
   end
   (0..x.size-1).each do |idx|
      theta=Math.atan(dydx[idx])
      xu[idx]=xscaled[idx]-yscaled[idx]*Math.sin(theta)
      yu[idx]=yc[idx]+yscaled[idx]*Math.cos(theta)
      xl[idx]=xscaled[idx]+yscaled[idx]*Math.sin(theta)
      yl[idx]=yc[idx]-yscaled[idx]*Math.cos(theta)
   end
   return xu,yu,xl,yl
end
def stllayer(xpoints,ypoints,z0,z1)
   nacatop=""
   (0..xpoints.size-2).each do |idx|
      v0=[xpoints[idx],ypoints[idx],z0]
      v1=[xpoints[idx+1],ypoints[idx+1],z0]
      v2=[xpoints[idx+1],ypoints[idx+1],z1]
      v3=[xpoints[idx],ypoints[idx],z1]
      nacatop+=stlquad(v0,v1,v2,v3)
   end
   return nacatop
end
def stlbetween(x1,y1,z1,x2,y2,z2)
   res=""
   (0..x1.size-2).each do |idx|
      v0=[x1[idx],y1[idx],z1[idx]]
      v1=[x1[idx+1],y1[idx+1],z1[idx+1]]
      v2=[x2[idx+1],y2[idx+1],z2[idx+1]]
      v3=[x2[idx],y2[idx],z2[idx]]
      res+=stlquad(v0,v1,v2,v3)
   end
   return res
end








