=begin

    Part of turbine model.
    Copyright (C) 2015  Björn Bergqvist

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    
    If you want to contact the author send an email: bjorn.bergqvist@gmail.com or
    phone +46 704-80 11 83.

=end
load 'naca.rb'
load 'cross.rb'
load 'stlcreate.rb'

def nacelle(length,startx,diameter)

x,y,dydx= naca0020
tab_len=100
tab_height=10


xtop=Array.new
ytop=Array.new
ztop=Array.new



xtop[0],ytop[0]=scale2d(length/tab_len,diameter/tab_height,x,y)
xtop[0],ytop[0]=translate2d(startx,0,xtop[0],ytop[0])

#add y=0 in the end
xtop[0]+=[xtop[0].last]
ytop[0]+=[0.0]

ztop[0]=Array.new
(0..xtop[0].size-1).each do |idx|
   ztop[0][idx]=0
end
angle=5
steps=360/5
(0..steps).each do |rot|
   ytop[rot],ztop[rot]=transform2d(rot*angle,0,0,ytop[0],ztop[0])
   xtop[rot]=xtop[0]
end
stl=""
(0..steps-1).each do |rot|
   stl+=stlbetween(xtop[rot],ytop[rot],ztop[rot],xtop[rot+1],ytop[rot+1],ztop[rot+1])
end
   return stl
end
=begin
length=800
startx=-200
diameter=100
puts stlheader("nacelle")
puts nacelle(length,startx,diameter)
puts stlfooter("nacelle")
=end
