=begin

    Part of turbine model.
    Copyright (C) 2015  Björn Bergqvist

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    
    If you want to contact the author send an email: bjorn.bergqvist@gmail.com or
    phone +46 704-80 11 83.

=end
load 'cross.rb'
def stlheader(name)
   return "solid #{name}"
end
def stlfooter(name)
   return "endsolid #{name}"
end
def checkpoints(v0,v1,v2,min)
   dist0=Math.sqrt((v0[0]-v1[0])**2+(v0[1]-v1[1])**2+(v0[2]-v1[2])**2).abs
   dist1=Math.sqrt((v0[0]-v2[0])**2+(v0[1]-v2[1])**2+(v0[2]-v2[2])**2).abs
   dist2=Math.sqrt((v1[0]-v2[0])**2+(v1[1]-v2[1])**2+(v1[2]-v2[2])**2).abs
   mindist=[dist0,dist1,dist2].min
   if mindist > min
      return true
   else
      return false
   end
end
def stlfacet(v0,v1,v2)
   mindist=1e-5
   vec0=[v1[0]-v0[0],v1[1]-v0[1],v1[2]-v0[2]]
   vec1=[v2[0]-v0[0],v2[1]-v0[1],v2[2]-v0[2]]
   crossprod=crossNormal(vec0,vec1)
   returnstring="  facet normal #{crossprod[0]} #{crossprod[1]} #{crossprod[2]}\n"
   returnstring+="    outer loop\n"
   returnstring+="      vertex #{v0[0]} #{v0[1]} #{v0[2]}\n"
   returnstring+="      vertex #{v1[0]} #{v1[1]} #{v1[2]}\n"
   returnstring+="      vertex #{v2[0]} #{v2[1]} #{v2[2]}\n"
   returnstring+="    endloop\n"
   returnstring+="  endfacet\n"
   if checkpoints(v0,v1,v2,mindist)
      return returnstring
   else
      return ""
   end
end
def stlquad(v0,v1,v2,v3)
   returnstring=stlfacet(v0,v1,v2)
   returnstring+=stlfacet(v2,v3,v0)
   return returnstring
end

